const Express = require("express");
const BodyParser = require("body-parser");
const mongodb = require("mongodb");
const ObjectId = require("mongodb").ObjectID;
const CONNECTION_URL = "mongodb+srv://edgenetworknode:yUiWfJBYCGwdRayj@matchnethop.hgxv0xd.mongodb.net/?retryWrites=true&w=majority";
const DATABASE_NAME = "edgecomm";
const COLLECTION_NAME = "nettranslate";
const sha256 = require('js-sha256');
var cors = require('cors');
const Collection = require("mongodb/lib/collection");
const Db = require("mongodb/lib/db");
const MongoClient = require("mongodb").MongoClient;
const request = require('undici');
const axios = require('axios');
const requestIp = require('request-ip');
let requestEnable = false;
var app = Express();
app.use(cors());
app.use(BodyParser.json());
app.use(BodyParser.urlencoded({ extended: true }));
app.use(requestIp.mw());
app.enable('trust proxy');
var corsOptions = {
    origin: 'http://matchmaking.obsidiancorestudios.com',
    optionsSuccessStatus: 200 // some legacy browsers (IE11, various SmartTVs) choke on 204
  }
var database, collection;
/**GET*/
app.get("/", (request, response) => {
    response.json({
        Error: "Please refer to documentation.",
        Status: "Failed",
        Info: "Matchmaking Server"
    })

});
/**GET:USRPASS:SESSION*/
app.get("/lobby/listall/", async (request, response) => {
    /**
     Field LobbyCount notifies the client of the number of indexed lobbies in the response 
     Field LBN[num] breaks down into Lobby Name [Number], this informs the client what the name is of the assosiated lobby
     Field LBIP[num] breaks down into Lobby IP [Number], this informs the client what the IP is of the assosiated lobby
     */
     var o_id = new mongodb.ObjectID();
     var ar;
     auth.insertOne({
        _id : o_id,
         type: 1,
         status: false
     })
     await  auth.findOne({_id: o_id}, (err, res) => {
         const delay = ms => new Promise(resolve => setTimeout(resolve, ms))
         const dec = async i => (await delay(200), --i)
         ar = res;
         const verifyUser = async () => {
         let responseEnabled = true;
         let enableLookup = true;
          let i = 8;
          let timeout = 7;
         while(i = await dec(i))
        try {
         if (enableLookup) {
             timeout = timeout - 1;
             if (timeout > 0) { 
                 await  auth.findOne({_id: o_id}, (err, res) => {   
                     if (res.status) {
                         if (responseEnabled) {
                          timeout = 0;
                              i = 1;
                              if (res.type == 2) {
                                 responseEnabled = false;
                                 enableLookup = false;
                                 response.status(200).json({
                                   LBN : res.lobbies,
                                LBIP :  res.ip,
                                   LobbyCount : res.LobbyCount
                                 });
                                 res = null;
                               } else {
                                 responseEnabled = false;
                                 ar = null;
                                 res = null;
                                 response.status(403).json({
                                     Info: "Forbidden",
                                     Message: "Something went wrong."
                                     });
                               }
                         }
                      }
           });
             } else {
                 if (responseEnabled) {
                     response.status(403).json({
                         Info: "Forbidden",
                         Message: "Something went wrong..."
                         });
                      responseEnabled = false;
                      ar = null;
                      res = null;
                 }
             }
           }   
        } catch (err) {
         enableLookup = false;
         res = null;
         if (responseEnabled) {
         response.sendStatus(500);
         }
         responseEnabled = false;
         console.log(err);
         timeout = 1;
     }
 }
     verifyUser();
     });

});
app.get("/lobby/submit/", async (request, response) => {
    /**
    Lobby submission documentation
     */
    response.status(503).json({
        INFORMATION: "THE LOBBY SUBMISSION ENDPOINT IS NOT ACTIVE, TRY AGAIN LATER.",
        VERSION: 1.0
    });
});
app.get("/lobby/remove/", async (request, response) => {
    /**
    Lobby removal documentation
     */
    response.status(503).json({
        INFORMATION: "THE LOBBY REMOVAL ENDPOINT IS NOT ACTIVE, TRY AGAIN LATER.",
        VERSION: 1.0
    });
});
    app.listen(10000, () => {
    console.log("Application is now online, attempting to connect to Database. Requests will be set to 503 until connected!")
    MongoClient.connect(CONNECTION_URL, { useNewUrlParser: true, useUnifiedTopology: true} , (error, client) => {
        if(error) {
            throw error;
        }
        database = client.db(DATABASE_NAME);
        auth = database.collection(COLLECTION_NAME);
        requestEnable = true;
        console.log("Database is connected and requests are enabled...");
    });
});
